/* Lezione insertion/merge sort: insertion sort su stringhe. */
#include <stdio.h>
#include <stdlib.h>

#define MAXSTRLEN 256

/* Leggiamo un array di tringhe di lunghezza data. */
char **leggi ( int N ) 
{
   int i;
   char **array = malloc(sizeof(char *)*N );
   for ( i = 0; i < N; i++ ) 
   {
      array[i] = malloc(sizeof(char)*(MAXSTRLEN+1));
      scanf("%s", array[i]); 
   }
   return array;
}

/* Confronta due stringhe come strcmp. */
int confronta ( char *s1, char *s2 )
{
   /* Finche' ci sono 2 caratteri da confrontare,
      cerchiamo una discordanza, oppure proseguiamo
      in parallelo.*/ 
   while ( *s1 && *s2 ) 
     if ( *s1 < *s2 ) 
         return -1;
     else if ( *s1 > *s2 )
         return 1;
     else {
        s1++;
        s2++;
     }
   /* Se entrambe sono finite: uguali */
   if ( *s1 && *s2 )
      return 0;
   /* Altrimenti, vince la piu' corta. */
   if ( ! *s1 ) return 1; 
   return -1;
}


/* Trova il posto dove inserire il prossimo elemento,
   spostando man mano cio' che va spostato. 
   (E' usata da insertion sort.) */
int trova ( char **array, int dx, char *elem ) 
{
   while ( dx >= 0 &&  confronta ( elem, array[ dx ] ) < 0 ) 
   {
      array[dx+1] = array[dx];
      dx--;
   }
   return dx+1;
}

/* Insertion sort, su stringhe.
   NOTA BENE: E' interessante notare 
   come in questo caso per spostare le stringhe
   basti un "=": questo perche' stiamo semplicemente
   permutando i loro puntatori, ma non abbiamo bisogno
   di fare copie del contenuto! 
   Normalmente, fare copie di stringhe avrebbe avuto
   bisogno di fare cose del tipo "strcpy" o "strdup" */
void isort( char **array, int N )
{
    int k = 0, j;
    char *temp;
    for ( k = 1; k < N; k++ ) 
    {
      temp = array[k];
      j = trova( array, k-1, temp );
      array[j] = temp;
    }
}

main()
{
  int N, i;
  char **array;
 
  scanf("%d", &N);
  array = leggi(N);

  isort( array, N );

  for ( i= 0; i < N; i++ )
   printf("%s\n", array[i]);
    
  return 0;
}
