/* Scrivere mergesort ibrido, che diventi insertion sort
   quando le porzioni dell'array vanno sotto 20 . */
#include <stdio.h>
#include <stdlib.h>

#define LIMITE 20

/* Insertion sort su interi, adattato
   per funzionare su una porzione di array */
int isort( int *array, int sx, int dx )
{
   int i, j, temp;
   for ( i = sx+1; i < dx; i++ ) 
   {
      temp = array[i];
      j = i-1;
      while ( j >= 0 && temp < array[j] ) 
      {
         array[j+1] = array[j];
         j--;
      }
      array[j+1] = temp;
   }
}

/* Procedura di fusione: array, punto sinistro mediano e destro, 
   piu' array temporaneo. */
void fusione(int *array, int sx, int mx, int dx, int *temp)
{
   int i = sx, j = mx;
   int ti = 0;
   while ( i < mx && j < dx ) 
     if ( array[i] < array[j] ) 
        temp[ti++] = array[i++];
     else
        temp[ti++] = array[j++];

   while ( i < mx ) 
      temp[ti++] = array[i++];
   while ( j < dx ) 
      temp[ti++] = array[j++];

   /* Ricopiamo tutto . */
   for ( i = 0; i < ti; i++ ) 
     array[sx+i] = temp[i];
}


/* Ecco quindi il nostro sort ibrido. */
void ibrido( int *array, int sx, int dx, int *temp ) 
{
   if ( dx - sx <= LIMITE )
     isort( array, sx, dx );
   else
   {
     ibrido( array, sx, (sx+dx)/2, temp ); 
     ibrido( array, (sx+dx)/2, dx, temp );
     fusione ( array, sx, (sx+dx)/2, dx, temp );
   }
   
}

/* La prima chiamata per eseguire merge/insert sort,
   dove si alloca (e poi si libera) l'array temporaneo. */
void ordina ( int *array, int N ) 
{
   int * temp = malloc(sizeof(int)* N);
   ibrido( array, 0, N, temp );
   free(temp);

}
main()
{
  int n, i;
  int *array, *temp;

  scanf("%d", &n );
  array = malloc(sizeof(int)*n);
  for ( i = 0; i < n; i++ ) 
     scanf("%d", &array[i]);
 
  ordina( array, n );
  
  for ( i = 0; i < n; i++ ) 
     printf("%d ", array[i]);
  printf("\n");
  
  
  return 0;
}
